#ifndef KRB5USER_H
#define KRB5USER_H

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>

typedef int32_t krb5user_error_code;

typedef krb5user_error_code (*krb5user_prompter_fct)(
                             void *data,
                             const char *name,
                             const char *banner,
                             const char *prompt,
                             char *reply,
                             unsigned int reply_length);

krb5user_error_code
krb5user_kinit_keytab_spn (const char* spn,
                           const char* ktname,
                           const char* ccname,
                           const char** what);

krb5user_error_code
krb5user_kinit_keytab (const char *service,
                       const char *hostname,
                       const char* ktname,
                       const char* ccname,
                       const char **what);

krb5user_error_code
krb5user_kinit_password (const char *principal,
                         char* password,
                         const char* ccname,
                         const char **what);

krb5user_error_code
krb5user_kinit_password_prompt (const char *principal,
                                krb5user_prompter_fct prompter,
                                void *data,
                                const char* ccname,
                                const char **what);

krb5user_error_code
krb5user_kinit_password_prompt_posix (const char *principal,
                                      const char* ccname,
                                      const char **what);

krb5user_error_code
krb5user_kdestroy (const char* ccname, const char **what);

krb5user_error_code
krb5user_set_ccname (const char* ccname, const char **what);

char const *krb5user_error_message (krb5user_error_code);

#ifdef __cplusplus
}
#endif

#endif
